package com.fr.plugin.xx.zyjn.decode;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;


/**
 * @author xx
 * @since 2021/12/04
 */
@Visualization(category = "加解密配置")
public class DecodeConfig extends DefaultConfiguration {

    private static volatile DecodeConfig config = null;

    public static DecodeConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(DecodeConfig.class);
        }
        return config;
    }

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    public Boolean getDebugSwitch() {
        return this.debugSwitch.get();
    }

    public void setDebugSwitch(Boolean debugSwitch) {
        this.debugSwitch.set(debugSwitch);
    }


    @Override
    public Object clone() throws CloneNotSupportedException {
        DecodeConfig cloned = (DecodeConfig) super.clone();
        cloned.debugSwitch = (Conf<Boolean>) debugSwitch.clone();
        return cloned;
    }
}
